local blizzFrames = {}
for frameName in pairs(UIPanelWindows) do
	local frame = _G[frameName]
	if frame and frame:IsMovable() and not frame:IsProtected() then
		blizzFrames[frame] = true
	end
end

local module = Dock:NewModule("Blizzard Frames", "AceEvent-3.0")

function module:OnInitialize()
	self:RegisterMessage("Dock_FrameDocked")
	self:RegisterMessage("Dock_FrameReleased")
	self:RegisterMessage("Dock_FrameRestored")
	self:RegisterMessage("Dock_FrameSentToDock", "Dock_FrameDocked")
	self:RegisterMessage("Dock_DockTabbed")
	self:RegisterMessage("Dock_DockUntabbed")
end

local function IsShown()
	return true
end

local minimapShown
function module:Dock_FrameDocked(event, frame, dock)
	if blizzFrames[frame] then
		local oldIsShown = frame.IsShown
		frame.IsShown = IsShown
		HideUIPanel(frame)
		frame.IsShown = oldIsShown
		frame:SetAttribute("UIPanelLayout-enabled", nil)
		frame:Show()
	elseif frame == Minimap then
		if dock:IsTabbed() then
			minimapShown = MinimapCluster:IsShown()
			MinimapCluster:Hide()
		end
	end
end


function module:Dock_FrameReleased(event, frame, dock)
	if blizzFrames[frame] then
		local wasShown = frame:IsShown()
		frame:Hide()
		frame:SetAttribute("UIPanelLayout-enabled", true)
		if wasShown then
			ShowUIPanel(frame)
		end
	elseif frame == Minimap then
		if dock:IsTabbed() then
			if minimapShown then
				MinimapCluster:Show()
			end
		end
	end
end

function module:Dock_FrameRestored(event, frame, dock)
	if blizzFrames[frame] then
		local wasShown = frame:IsShown()
		HideUIPanel(frame)
		if wasShown then
			ShowUIPanel(frame)
		end
	end
end

function module:Dock_DockTabbed(event, dock)
	if dock:IsFrameDocked(Minimap) then
		minimapShown = MinimapCluster:IsShown()
		MinimapCluster:Hide()
	end
end

function module:Dock_DockUntabbed(event, dock)
	if dock:IsFrameDocked(Minimap) then
		if minimapShown then
			MinimapCluster:Show()
		end
	end
end